package com.ebts.web.controller.system;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.ebts.common.core.entity.Result;
import com.ebts.system.entity.vo.RouterVo;
import com.ebts.system.utils.FtpUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import com.ebts.common.core.entity.entity.Menu;
import com.ebts.common.core.entity.entity.User;
import com.ebts.common.core.entity.model.LoginBody;
import com.ebts.common.core.entity.model.LoginUser;
import com.ebts.common.utils.ServletUtils;
import com.ebts.framework.web.service.LoginService;
import com.ebts.framework.web.service.SysPermissionService;
import com.ebts.framework.web.service.TokenService;
import com.ebts.system.service.MenuService;

import javax.annotation.Resource;

/**
 * 登录验证
 *
 * @author binlin
 */
@RestController
public class LoginController {
    @Resource
    private LoginService loginService;

    @Resource
    private MenuService menuService;

    @Resource
    private SysPermissionService permissionService;

    @Resource
    private TokenService tokenService;

    /**
     * 登录方法
     *
     * @param loginBody 登录信息
     * @return 结果
     */
    @PostMapping("/login")
    public Result<String> login(@RequestBody LoginBody loginBody) {
        // 生成令牌
        String token = loginService.login(loginBody.getUsername(), loginBody.getPassword(), loginBody.getCode(),
                loginBody.getUuid());
        return Result.ok("登录成功!",token);
    }

    /**
     * 获取用户信息
     *
     * @return 用户信息
     */
    @GetMapping("getInfo")
    public Result<Map<String, Object>> getInfo() {
        LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
        User user = loginUser.getUser();

        String avatar = FtpUtils.getResources() + user.getAvatar();
        user.setAvatar(avatar);
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(user);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(user);
        Map<String, Object> result = new HashMap<>();
        result.put("user", user);
        result.put("roles", roles);
        result.put("permissions", permissions);
        return Result.ok(result);
    }

    /**
     * 获取路由信息
     *
     * @return 路由信息
     */
    @GetMapping("getRouters")
    public Result<List<RouterVo>> getRouters() {
        LoginUser loginUser = tokenService.getLoginUser(ServletUtils.getRequest());
        // 用户信息
        User user = loginUser.getUser();
        List<Menu> menus = menuService.selectMenuTreeByUserId(user.getUserId());
        return Result.ok(menuService.buildMenus(menus));
    }
}
